#!/usr/bin/env python3
""" Data Structures and Algorithms for CL 3, Assignment 2
    See <https://https://dsacl3-2021.github.io/a2/> for detailed
    instructions.

    <Please insert your name and the honor code here.>
"""

def is_sentence(s, lexicon): 
    """Check if the sentence without spaces can be generated by the lexicon.

    For example, given the lexicon 
        ['this', 'is', a', 'sample', 'lexicon'],
    the function should return True for 
        "this", "isthisa", "islexiconsample",
    and return False for 
        "the", "asentence", "thisisthesample".

    Parameters
    ----------
    s           A string (a sequence)
    lexicon     A set of words (a container supporting the operator 'in')

    Returns True if 's' can be constructed using the words from
             'lexicon', False otherwise.
    """
    # Exercise 2.1

def tokenize(s, lexicon):
    """Return all possible sequences of words in lexicon that forms s.

    This function is required to implement a "brute-force" recursive
    approach.

    Parameters
    ----------
    s           A string (a sequence)
    lexicon     A set of words (a container supporting the operator 'in')

    Returns a sequence of sequences. For example, if 'lexicon' is {'a',
            'ab', 'bc', 'c'}, and 's' is 'abc', the function should
            return [['ab', 'c'], ['a', 'bc']]. 
    """
    # Exercise 2.2

def tokenize_greedy(s, lexicon):
    """Return all possible sequences of words in lexicon that forms s.

    This function is required to implement a "greedy" approach:
    identify the longest prefix of 's' that is in the lexicon, and
    continue matching after the identified prefix.

    Parameters
    ----------
    s           A string (a sequence)
    lexicon     A set of words (a container supporting the operator 'in')

    Returns a sequence of sequences if a tokenization is found, empty
            sequence otherwise. Even though this function always
            returns a single segmentation, it should use the same
            interface as other functions, e.g., for segmentation
            'ab-c', we return [['ab', 'c']].
    """
    # Exercise 2.3


def tokenize_memo(s, lexicon):
    """Return all possible sequences of words in lexicon that forms s.

    This function is the same as tokenize() above, except, you are
    required to implement a memoization (dynamic programming) mechanism
    to prevent repeated calculations. You can add more keyword
    arguments if you find them necessary.

    Parameters
    ----------
    s           A string (a sequence)
    lexicon     A set of words (a container supporting the operator 'in')

    Returns a sequence of sequences, representing all ways to tokenize
            input string with the given lexicon. Empty sequence if
            the input string cannot be tokenized.
    """
    # Exercise 2.4

def compare_average(sentfile, lexfile):
    """Compare the three tokenization methods above for speed and correctness.

    This function should calculate and print the metrics defined in
    the assignment sheet for all three implementations above.

    Parameters
    ----------
    sentfile    The name of the file containing the sentences (one
                sentence per line, words separated with a single space).
    lexfile     The name of the lexicon file (a file containing on
                word per line).

    Returns None. The function is expected to print its results to the
            console.
    """
    # Exercise 2.5

def compare_worstcase(maxlen=20):
    """Plot the worst-case runtime for increasing input string.

    For this exercise, you are required to identify a lexicon and a
    set of input strings with increasing length that result in worst
    case performance for the brute-force tokenization algorithm. You
    should hard-code the lexicon and input strings you use below.
    The example code below asks you to define the variable 'lexicon'
    outside the loop, and input string 's' with different lengths
    inside the loop.  You can re-arrange the places these variables
    are defined, but please keep the names of the variables to
    indicate the wors-case inputs to the algorithm.

    Parameters
    ----------
    maxlen      the maximum length of the sequence to be tokenized.

    Returns None. The function is expected to save the resulting graph
            to an external PDF file with name 'worst-case.pdf'.
    """
    # Exercise 2.6
    lexicon = # here goes the worst-case lexicon specification

    for l in range(1, maxlen + 1):
        s = # here goes the worst-case input string of length 'l'


if __name__ == "__main__":
    ### You can use this for quick testing (not graded/required).
    pass
